require "import"
import "android.widget.*"
import "cjson"

local ak="auto_speak_apps"
local bk="auto_speak_blacklist_data"
local as=luajava.astable(activity.getSharedData(ak) or HashSet())
local bs=cjson.decode(activity.getSharedData(bk) or "{}")

--print(dump(as))
--print(dump(bs))
--activity.showLogs()

local bas={}
for k,v pairs(bs)
  for kk,vv ipairs(v)
    bas[vv]=true
  end
end

local apps={"抖音","抖音极速版","抖音火山版","快手","快手极速版","微信视频号"}
local bns={"用户进入直播间","用户送礼物","用户来了","用户点赞","用户关注了主播","用户加入粉丝团","用户分享直播间"}
local blacks={"*进入直播间*","*送出了*","*来了*","*点赞*","*关注了*","*加入了*","*分享了*"}
local root=LinearLayout(activity)
local tv=TextView(activity)
tv.text="朗读的程序，勾选的程序会自动朗读公屏"
root.addView(tv)

root.setOrientation(1)
local caks={}

for k,v ipairs(apps)
  local ck=CheckBox(activity)
  caks[v]=ck
  ck.text=v
  if table.find(as,v)
    ck.checked=true
  end
  root.addView(ck)
end

local tv2=TextView(activity)
tv2.text="朗读过滤设置，勾选的关键字将不会朗读"
root.addView(tv2)
local cbks={}

for k,v ipairs(blacks)
  local ck=CheckBox(activity)
  cbks[v]=ck
  ck.text=bns[k]
  if bas[v]
    ck.checked=true
  end
  root.addView(ck)
end

btn=Button(activity)
btn.text="保存当前公平设置"
btn.onClick=function()

  for kk,vv ipairs(apps)
    bs[vv]=bs[vv] or {}

    for k,v ipairs(blacks)
      local ck=cbks[v]
      if ck.checked
        if not table.find(bs[vv],v)
          table.insert(bs[vv],v)
        end
       else
        local i= table.find(bs[vv],v)
        if i
          table.remove(bs[vv],i)
        end
      end
    end

    local ck=caks[vv]
    if ck.checked
      if not table.find(as,vv)
        table.insert(as,vv)
      end
     else
      local i= table.find(as,vv)
      if i
        table.remove(as,i)
      end
    end

  end
  --print(dump(as))
  --print(dump(bs))
  --activity.showLogs()
  activity.setSharedData(ak,HashSet(ArrayList(as)))
  activity.setSharedData(bk,cjson.encode(bs))
  print("已保存公屏设置")
end

root.addView(btn)
activity.setContentView(root)

